#!/usr/bin/perl 

#######################################################
# Shasero (Shablona Serchilo) versio 1.0, 
# verkita de Klivo, 2003/05
#
# Chi tiu softvaro serchas vortliston por vortoj kiuj kongruas 
# al iu shablono. Ghi celas faciligi desegnadon de krucenigmoj.
# Eble poetoj ankau trovos ghin utila.
#
# La vortlisto bazighas sur la Esperanta Ispell-vortaro de 
# sinjoro Pokrovskij.
# 
# Shasero.cgi kaj ghia vortlisto estas uzeblaj lau la kondichoj 
# de la GNU-a Ghenerala Publika Permesilo (GNU General Public 
# License version 2) de la Libera Softvara Fonduso (Free Software 
# Foundation).
#
# http://www.gnu.org/copyleft/gpl.html
#
# Free Software Foundation, Inc.
# 59 Temple Place - Suite 330, Boston, MA, 02111-1307, USA
#
# Samideane,
#    Klivo   (indriko@yahoo.com)
#

require "konvertu";

############################################
# Akiru cgi-variablojn de la medio;
sub akiru_cgi_variablojn {
   $cgi_speco     = $ENV{'CONTENT_TYPE'};
   $cgi_longeco   = $ENV{'CONTENT_LENGTH'};
   $cgi_metodo    = $ENV{'REQUEST_METHOD'};
   $cgi_mesaghoj  = $ENV{'QUERY_STRING'};
   $cgi_foliumilo = $ENV{'HTTP_USER_AGENT'};
   $cgi_gasto     = $ENV{'REMOTE_ADDR'};
   $cgi_ref       = $ENV{'HTTP_REFERER'};
}


#####################################################
# Konvertu CGI-mesaghojn: 
sub konvertu_cgi_mesaghojn {
   @paroj = split (/&/, $cgi_mesaghoj);
   foreach $paro (@paroj) {
      ($nomo, $valoro) = split(/=/,$paro);
      $valoro =~ tr/+/ /;
      $valoro =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("c",hex($1))/eg;
      $formulo{$nomo} = $valoro;
   }
}

$html_kapo = <<"FINO";
<html>
<head>
<title>Ŝablona Serĉilo</title>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">

<style type="text/css">
.marghenoj {
  font-family: Verdana, Geneva, Arial, sans-serif;
  font-size: 11pt;
  text-align: left;
  text-decoration: none;
  margin-left: 30;
  margin-right: 30;
  color: black;
}
</style>

</head>
<body>
<div class="marghenoj">
<form action="http://krucenigmoj.tripod.com/cgi-bin/shasero.cgi">
<p><font color="blue" size=5>Ŝasero</font>&nbsp;&nbsp;
<input type=text name="shablono" value="SSSSS">
<input type=submit name="faru" value="Serĉu"><br>
<input type=checkbox name="kunmetitaj" value="inkluzivu" TTTTT>
Inkluzivu kunmetitajn vortojn en la rezulto.<p>
</form>

FINO


$html_vosto = <<"FINO2";
</div>
<p>
<center>
<a href="http://krucenigmoj.tripod.com/shasero.htm">Klarigoj</a>
</center>
<p>
</body>
</html>
FINO2


#############################################
# La programo komencas kuri de chi tie.

akiru_cgi_variablojn();
konvertu_cgi_mesaghojn();
$shablono = $formulo{'shablono'};
chomp($shablono);
$kunmetitaj = $formulo{'kunmetitaj'};

print "Content-type: text/html\n\n";

$html_kapo =~ s/SSSSS/$shablono/;

if ($kunmetitaj eq "inkluzivu") {
   $html_kapo =~ s/TTTTT/checked/;
}
else {
   $html_kapo =~ s/TTTTT//;
}

print $html_kapo;

# Ghustigu shablonon.
#print "Originala shablono: $shablono<br>\n";
# Shanghu * al .*
$shablono =~ s/\*/\.\*/g;
# cx kaj ^c al latin3
#print "  $shablono ";
$shablono = x_cir_al_latin3(lc($shablono));
$shablono = "\^$shablono\$";
#print "En regexp formato: $shablono<br>\n";
#print "  $shablono <br>";

$nombro = 0;
$longeco = 0;

if ($kunmetitaj eq 'inkluzivu') { open (VORTLISTO, "vortlisto"); }
else { open (VORTLISTO, "radiklisto"); }

while (<VORTLISTO>) {
   $radiko = $_;
   chomp($radiko);
   $radiko =~ s/\r//g;
   if (lc($radiko) =~ $shablono) {
      $radiko = latin3_al_utf8($radiko);
      print "$radiko ";
      $nombro++;
      $longeco += length($radiko);
      if ($longeco > 60) { 
         print "<br>\n";
         $longeco = 0; 
      }
      if ($nombro > 400) { break; }
   }
}
print "\n";
print "$html_vosto";

close VORTLISTO;

exit(1);

